/*
 * Programming in Java, Jacobs University, 2015
 *
 * This file demonstrates how to implement a simple chat server. The
 * ChatServer class uses the main thread to accept incoming
 * connections.  Connections are handed over to the dispatcher who
 * takes care of keeping track of the connected clients and forwards
 * messages as needed.
 */

import java.io.IOException;
import java.net.Socket;
import java.net.ServerSocket;

public class ChatServer
{
    static final int PORT = 4321;

    public static String getClientName(Socket s)
    {
	return "(" + s.getInetAddress().getHostName()
	    + ":" + s.getPort() + ")";
    }
    
    public static void main(String[] args)
	throws IOException
    {
	ServerSocket s = new ServerSocket(PORT);
	ChatDispatcher d = new ChatDispatcher();
	(new Thread(d)).start();
	try {
	    while (true) {
		Socket socket = s.accept();
		try {
		    d.addClient(socket);
		} catch(IOException e) {
		    socket.close();
		}
	    }
	} finally {
	    s.close();
	}
    }
}
